Unit ALN1R3_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ALN1R3(COS :Real; SIN :Real; var X :Real; var Y :Real);

implementation

procedure ALN1R3(COS :Real; SIN :Real; var X :Real; var Y :Real);
var
XR :Real;
begin
{ ********************************************************* }

{     PURPOSE: }
{        APPLICATION OF GIVENS ORTHOGONAL ROTATION MATRIX. }

{     METHOD: }
{        FOR GIVEN 2-VECTOR  ( X ) }
{                            ( Y ) }
{        ROTATION COMPUTEE BY ALN1R2 IS APPLIED. }
{        THE ROTATION MATRIX }

{                ( COS     SIN ) }
{                (-SIN     COS ) }

{        IS GIVEN BY ITS ELEMENTS  COS , SIN . }
{        A RESULTS ARE PLACEE AT THE SAME POSITIONS }
{        IN MEMORY AS  X   AND  Y . }

{     REFERENCES: }
{     1.LAWSON C.L. AND HANSON R.J. SOLVING LEAST SQUARES }
{       PROBLEMS.- PRENTICE-HALL,INC.,ENGLEWOOE CLIFFS,NEW }
{       JERSEY,1974. }

{     USAGE: }
{        CALL ALN1R3 (COS,SIN,X,Y) }

{     INPUT PARAMETERS: }
{        COS - REAL VARIABLE - THE FIRST ELEMENT }
{              OF GIVENS MATRIX; }
{        SIN - REAL VARIABLE-THE SECONE ELEMENT }
{              OF GIVENS MATRIX }

{     INPUT AND OUTPUT PARAMETERS: }
{        X - REAL VARIABLE -  ON ENTRANCE CONTAINS THE }
{            FIRST COMPONENT OF 2-VECTOR; ON EXIT IT }
{            CONTAINS THE FIRST COMPONENT OF TRANSFORMEE }
{            VECTOR; }
{        Y - REAL VARIABLE - ON ENTRANCE CONTAINS THE }
{            SECONE COMPONENT OF 2-VECTOR; ON EXIT IT }
{            CONTAINS THE SECONE COMPONENT OF TRANSFORMED }
{            VECTOR. }

{ ********************************************************* }
XR := COS*X+SIN*Y;
Y := -SIN*X+COS*Y;
X := XR;
end;

end.
